> For the complete documentation index, see [llms.txt](https://docs.peoplelogic.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.peoplelogic.dev/api/universal-talent-api/okrs-or-goals.md).

# OKRs (or Goals)

The OKRs API provides generic functionality for a broad set of Goal types - including OKRs, Rocks or KPIs. For simplicity, these are referenced as OKRs below. OKRs can be measurable or not and can have any number of children or parents that contribute to its current value. OKRs can be assigned to both Employees and Groups/Teams and by default are allowed to be assigned an owner and support tasks.

## GET /api/v1/objective

> List objectives

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"OKRs (or Goals)","description":"The OKRs API provides generic functionality for a broad set of Goal types - including OKRs, Rocks or KPIs. For simplicity, these are referenced as OKRs below.  OKRs can be measurable or not and can have any number of children or parents that contribute to its current value.  OKRs can be assigned to both Employees and Groups/Teams and by default are allowed to be assigned an owner and support tasks."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"Objective":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"organization":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"description":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"cycleId":{"type":"string","format":"uuid"},"parentId":{"type":"string","format":"uuid"},"treeRootId":{"type":"string","format":"uuid"},"measurable":{"type":"boolean"},"metric":{"$ref":"#/components/schemas/ObjectiveMetric"},"weightTowardsParent":{"type":"integer"},"contributesToParent":{"type":"boolean"},"childObjectives":{"type":"array","items":{"$ref":"#/components/schemas/Objective"}},"assessment":{"type":"string"},"log":{"type":"array","items":{"$ref":"#/components/schemas/ObjectiveLog"}},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}},"tasks":{"type":"array","items":{"$ref":"#/components/schemas/Task"}},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"sharing":{"$ref":"#/components/schemas/SharingInfo"},"order":{"type":"integer"}},"required":["id","organization","name","active","status","created","sharing","order"]},"StatusInfo":{"type":"object","properties":{"current":{"type":"string"},"changedAt":{"type":"string","format":"date-time"},"changedBy":{"type":"string","format":"uuid"}},"required":["current"]},"CreationInfo":{"type":"object","properties":{"createdAt":{"type":"string","format":"date-time"},"createdBy":{"type":"string","format":"uuid"}},"required":["createdAt"]},"ObjectiveMetric":{"type":"object","properties":{"startingValue":{"type":"number"},"currentValue":{"type":"number"},"targetValue":{"type":"number"},"metricType":{"type":"string"},"metricUnit":{"type":"string"},"logs":{"type":"array","items":{"$ref":"#/components/schemas/MetricLog"}}},"required":["startingValue","currentValue","targetValue"]},"MetricLog":{"type":"object","properties":{"value":{"type":"number"},"loggedAt":{"type":"string","format":"date-time"},"loggedBy":{"type":"string","format":"uuid"}},"required":["value","loggedAt","loggedBy"]},"ObjectiveLog":{"type":"object","properties":{"loggedAt":{"type":"string","format":"date-time"},"loggedBy":{"type":"string","format":"uuid"},"progress":{"type":"number"},"targetValue":{"type":"number"},"assessment":{"type":"string"}}},"EntityAssignee":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"entityType":{"type":"string"}},"required":["entityId","entityType"]},"EntityMapping":{"type":"object","properties":{"app":{"type":"string","format":"uuid"},"namespace":{"type":"string"},"mappedId":{"type":"string"},"reference":{"type":"string"},"mappingData":{"type":"object","additionalProperties":{"type":"string"}},"mappingSecrets":{"type":"object","additionalProperties":{"type":"string"}}},"required":["app","mappedId","mappingData","mappingSecrets"]},"Task":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"organization":{"type":"string","format":"uuid"},"description":{"type":"string"},"dueDate":{"type":"string","format":"date"},"connectedTo":{"$ref":"#/components/schemas/EntityInfo"},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"order":{"type":"integer"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}}},"required":["id","name","active","status","created","organization","order"]},"EntityInfo":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"type":{"type":"string"},"organization":{"type":"string","format":"uuid"}},"required":["entityId","type"]},"Note":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"note":{"type":"string"},"author":{"type":"string","format":"uuid"},"createdAt":{"type":"string","format":"date-time"}}},"SharingInfo":{"type":"object","properties":{"visibility":{"type":"string"},"ownerId":{"type":"string","format":"uuid"}}}}},"paths":{"/api/v1/objective":{"get":{"tags":["OKRs (or Goals)"],"summary":"List objectives","parameters":[{"name":"status","in":"query","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Objective"}}}}},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```

## POST /api/v1/objective

> Create objective

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"OKRs (or Goals)","description":"The OKRs API provides generic functionality for a broad set of Goal types - including OKRs, Rocks or KPIs. For simplicity, these are referenced as OKRs below.  OKRs can be measurable or not and can have any number of children or parents that contribute to its current value.  OKRs can be assigned to both Employees and Groups/Teams and by default are allowed to be assigned an owner and support tasks."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ObjectiveRequest":{"type":"object","properties":{"name":{"type":"string"},"description":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"cycleId":{"type":"string","format":"uuid"},"parentId":{"type":"string","format":"uuid"},"startingValue":{"type":"number"},"currentValue":{"type":"number"},"targetValue":{"type":"number"},"metricType":{"type":"string"},"metricUnit":{"type":"string"},"weightTowardsParent":{"type":"integer"},"assessment":{"type":"string"},"visibility":{"type":"string"},"owner":{"type":"string","format":"uuid"},"order":{"type":"integer"}}},"Objective":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"organization":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"description":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"cycleId":{"type":"string","format":"uuid"},"parentId":{"type":"string","format":"uuid"},"treeRootId":{"type":"string","format":"uuid"},"measurable":{"type":"boolean"},"metric":{"$ref":"#/components/schemas/ObjectiveMetric"},"weightTowardsParent":{"type":"integer"},"contributesToParent":{"type":"boolean"},"childObjectives":{"type":"array","items":{"$ref":"#/components/schemas/Objective"}},"assessment":{"type":"string"},"log":{"type":"array","items":{"$ref":"#/components/schemas/ObjectiveLog"}},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}},"tasks":{"type":"array","items":{"$ref":"#/components/schemas/Task"}},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"sharing":{"$ref":"#/components/schemas/SharingInfo"},"order":{"type":"integer"}},"required":["id","organization","name","active","status","created","sharing","order"]},"StatusInfo":{"type":"object","properties":{"current":{"type":"string"},"changedAt":{"type":"string","format":"date-time"},"changedBy":{"type":"string","format":"uuid"}},"required":["current"]},"CreationInfo":{"type":"object","properties":{"createdAt":{"type":"string","format":"date-time"},"createdBy":{"type":"string","format":"uuid"}},"required":["createdAt"]},"ObjectiveMetric":{"type":"object","properties":{"startingValue":{"type":"number"},"currentValue":{"type":"number"},"targetValue":{"type":"number"},"metricType":{"type":"string"},"metricUnit":{"type":"string"},"logs":{"type":"array","items":{"$ref":"#/components/schemas/MetricLog"}}},"required":["startingValue","currentValue","targetValue"]},"MetricLog":{"type":"object","properties":{"value":{"type":"number"},"loggedAt":{"type":"string","format":"date-time"},"loggedBy":{"type":"string","format":"uuid"}},"required":["value","loggedAt","loggedBy"]},"ObjectiveLog":{"type":"object","properties":{"loggedAt":{"type":"string","format":"date-time"},"loggedBy":{"type":"string","format":"uuid"},"progress":{"type":"number"},"targetValue":{"type":"number"},"assessment":{"type":"string"}}},"EntityAssignee":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"entityType":{"type":"string"}},"required":["entityId","entityType"]},"EntityMapping":{"type":"object","properties":{"app":{"type":"string","format":"uuid"},"namespace":{"type":"string"},"mappedId":{"type":"string"},"reference":{"type":"string"},"mappingData":{"type":"object","additionalProperties":{"type":"string"}},"mappingSecrets":{"type":"object","additionalProperties":{"type":"string"}}},"required":["app","mappedId","mappingData","mappingSecrets"]},"Task":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"organization":{"type":"string","format":"uuid"},"description":{"type":"string"},"dueDate":{"type":"string","format":"date"},"connectedTo":{"$ref":"#/components/schemas/EntityInfo"},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"order":{"type":"integer"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}}},"required":["id","name","active","status","created","organization","order"]},"EntityInfo":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"type":{"type":"string"},"organization":{"type":"string","format":"uuid"}},"required":["entityId","type"]},"Note":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"note":{"type":"string"},"author":{"type":"string","format":"uuid"},"createdAt":{"type":"string","format":"date-time"}}},"SharingInfo":{"type":"object","properties":{"visibility":{"type":"string"},"ownerId":{"type":"string","format":"uuid"}}}}},"paths":{"/api/v1/objective":{"post":{"tags":["OKRs (or Goals)"],"summary":"Create objective","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ObjectiveRequest"}}}},"responses":{"201":{"description":"Created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Objective"}}}},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```

## GET /api/v1/objective/{id}

> Get objective

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"OKRs (or Goals)","description":"The OKRs API provides generic functionality for a broad set of Goal types - including OKRs, Rocks or KPIs. For simplicity, these are referenced as OKRs below.  OKRs can be measurable or not and can have any number of children or parents that contribute to its current value.  OKRs can be assigned to both Employees and Groups/Teams and by default are allowed to be assigned an owner and support tasks."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"Objective":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"organization":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"description":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"cycleId":{"type":"string","format":"uuid"},"parentId":{"type":"string","format":"uuid"},"treeRootId":{"type":"string","format":"uuid"},"measurable":{"type":"boolean"},"metric":{"$ref":"#/components/schemas/ObjectiveMetric"},"weightTowardsParent":{"type":"integer"},"contributesToParent":{"type":"boolean"},"childObjectives":{"type":"array","items":{"$ref":"#/components/schemas/Objective"}},"assessment":{"type":"string"},"log":{"type":"array","items":{"$ref":"#/components/schemas/ObjectiveLog"}},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}},"tasks":{"type":"array","items":{"$ref":"#/components/schemas/Task"}},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"sharing":{"$ref":"#/components/schemas/SharingInfo"},"order":{"type":"integer"}},"required":["id","organization","name","active","status","created","sharing","order"]},"StatusInfo":{"type":"object","properties":{"current":{"type":"string"},"changedAt":{"type":"string","format":"date-time"},"changedBy":{"type":"string","format":"uuid"}},"required":["current"]},"CreationInfo":{"type":"object","properties":{"createdAt":{"type":"string","format":"date-time"},"createdBy":{"type":"string","format":"uuid"}},"required":["createdAt"]},"ObjectiveMetric":{"type":"object","properties":{"startingValue":{"type":"number"},"currentValue":{"type":"number"},"targetValue":{"type":"number"},"metricType":{"type":"string"},"metricUnit":{"type":"string"},"logs":{"type":"array","items":{"$ref":"#/components/schemas/MetricLog"}}},"required":["startingValue","currentValue","targetValue"]},"MetricLog":{"type":"object","properties":{"value":{"type":"number"},"loggedAt":{"type":"string","format":"date-time"},"loggedBy":{"type":"string","format":"uuid"}},"required":["value","loggedAt","loggedBy"]},"ObjectiveLog":{"type":"object","properties":{"loggedAt":{"type":"string","format":"date-time"},"loggedBy":{"type":"string","format":"uuid"},"progress":{"type":"number"},"targetValue":{"type":"number"},"assessment":{"type":"string"}}},"EntityAssignee":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"entityType":{"type":"string"}},"required":["entityId","entityType"]},"EntityMapping":{"type":"object","properties":{"app":{"type":"string","format":"uuid"},"namespace":{"type":"string"},"mappedId":{"type":"string"},"reference":{"type":"string"},"mappingData":{"type":"object","additionalProperties":{"type":"string"}},"mappingSecrets":{"type":"object","additionalProperties":{"type":"string"}}},"required":["app","mappedId","mappingData","mappingSecrets"]},"Task":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"organization":{"type":"string","format":"uuid"},"description":{"type":"string"},"dueDate":{"type":"string","format":"date"},"connectedTo":{"$ref":"#/components/schemas/EntityInfo"},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"order":{"type":"integer"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}}},"required":["id","name","active","status","created","organization","order"]},"EntityInfo":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"type":{"type":"string"},"organization":{"type":"string","format":"uuid"}},"required":["entityId","type"]},"Note":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"note":{"type":"string"},"author":{"type":"string","format":"uuid"},"createdAt":{"type":"string","format":"date-time"}}},"SharingInfo":{"type":"object","properties":{"visibility":{"type":"string"},"ownerId":{"type":"string","format":"uuid"}}}}},"paths":{"/api/v1/objective/{id}":{"get":{"tags":["OKRs (or Goals)"],"summary":"Get objective","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Objective"}}}},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```

## PATCH /api/v1/objective/{id}

> Update objective

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"OKRs (or Goals)","description":"The OKRs API provides generic functionality for a broad set of Goal types - including OKRs, Rocks or KPIs. For simplicity, these are referenced as OKRs below.  OKRs can be measurable or not and can have any number of children or parents that contribute to its current value.  OKRs can be assigned to both Employees and Groups/Teams and by default are allowed to be assigned an owner and support tasks."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ObjectiveRequest":{"type":"object","properties":{"name":{"type":"string"},"description":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"cycleId":{"type":"string","format":"uuid"},"parentId":{"type":"string","format":"uuid"},"startingValue":{"type":"number"},"currentValue":{"type":"number"},"targetValue":{"type":"number"},"metricType":{"type":"string"},"metricUnit":{"type":"string"},"weightTowardsParent":{"type":"integer"},"assessment":{"type":"string"},"visibility":{"type":"string"},"owner":{"type":"string","format":"uuid"},"order":{"type":"integer"}}},"Objective":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"organization":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"description":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"cycleId":{"type":"string","format":"uuid"},"parentId":{"type":"string","format":"uuid"},"treeRootId":{"type":"string","format":"uuid"},"measurable":{"type":"boolean"},"metric":{"$ref":"#/components/schemas/ObjectiveMetric"},"weightTowardsParent":{"type":"integer"},"contributesToParent":{"type":"boolean"},"childObjectives":{"type":"array","items":{"$ref":"#/components/schemas/Objective"}},"assessment":{"type":"string"},"log":{"type":"array","items":{"$ref":"#/components/schemas/ObjectiveLog"}},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}},"tasks":{"type":"array","items":{"$ref":"#/components/schemas/Task"}},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"sharing":{"$ref":"#/components/schemas/SharingInfo"},"order":{"type":"integer"}},"required":["id","organization","name","active","status","created","sharing","order"]},"StatusInfo":{"type":"object","properties":{"current":{"type":"string"},"changedAt":{"type":"string","format":"date-time"},"changedBy":{"type":"string","format":"uuid"}},"required":["current"]},"CreationInfo":{"type":"object","properties":{"createdAt":{"type":"string","format":"date-time"},"createdBy":{"type":"string","format":"uuid"}},"required":["createdAt"]},"ObjectiveMetric":{"type":"object","properties":{"startingValue":{"type":"number"},"currentValue":{"type":"number"},"targetValue":{"type":"number"},"metricType":{"type":"string"},"metricUnit":{"type":"string"},"logs":{"type":"array","items":{"$ref":"#/components/schemas/MetricLog"}}},"required":["startingValue","currentValue","targetValue"]},"MetricLog":{"type":"object","properties":{"value":{"type":"number"},"loggedAt":{"type":"string","format":"date-time"},"loggedBy":{"type":"string","format":"uuid"}},"required":["value","loggedAt","loggedBy"]},"ObjectiveLog":{"type":"object","properties":{"loggedAt":{"type":"string","format":"date-time"},"loggedBy":{"type":"string","format":"uuid"},"progress":{"type":"number"},"targetValue":{"type":"number"},"assessment":{"type":"string"}}},"EntityAssignee":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"entityType":{"type":"string"}},"required":["entityId","entityType"]},"EntityMapping":{"type":"object","properties":{"app":{"type":"string","format":"uuid"},"namespace":{"type":"string"},"mappedId":{"type":"string"},"reference":{"type":"string"},"mappingData":{"type":"object","additionalProperties":{"type":"string"}},"mappingSecrets":{"type":"object","additionalProperties":{"type":"string"}}},"required":["app","mappedId","mappingData","mappingSecrets"]},"Task":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"organization":{"type":"string","format":"uuid"},"description":{"type":"string"},"dueDate":{"type":"string","format":"date"},"connectedTo":{"$ref":"#/components/schemas/EntityInfo"},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"order":{"type":"integer"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}}},"required":["id","name","active","status","created","organization","order"]},"EntityInfo":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"type":{"type":"string"},"organization":{"type":"string","format":"uuid"}},"required":["entityId","type"]},"Note":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"note":{"type":"string"},"author":{"type":"string","format":"uuid"},"createdAt":{"type":"string","format":"date-time"}}},"SharingInfo":{"type":"object","properties":{"visibility":{"type":"string"},"ownerId":{"type":"string","format":"uuid"}}}}},"paths":{"/api/v1/objective/{id}":{"patch":{"tags":["OKRs (or Goals)"],"summary":"Update objective","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ObjectiveRequest"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Objective"}}}},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```

## POST /api/v1/objective/{id}/progress

> Log objective progress

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"OKRs (or Goals)","description":"The OKRs API provides generic functionality for a broad set of Goal types - including OKRs, Rocks or KPIs. For simplicity, these are referenced as OKRs below.  OKRs can be measurable or not and can have any number of children or parents that contribute to its current value.  OKRs can be assigned to both Employees and Groups/Teams and by default are allowed to be assigned an owner and support tasks."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ObjectiveLogRequest":{"type":"object","properties":{"type":{"type":"string"},"value":{"type":"number"},"requestor":{"type":"string","format":"uuid"}},"required":["type","value"]},"Objective":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"organization":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"description":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"cycleId":{"type":"string","format":"uuid"},"parentId":{"type":"string","format":"uuid"},"treeRootId":{"type":"string","format":"uuid"},"measurable":{"type":"boolean"},"metric":{"$ref":"#/components/schemas/ObjectiveMetric"},"weightTowardsParent":{"type":"integer"},"contributesToParent":{"type":"boolean"},"childObjectives":{"type":"array","items":{"$ref":"#/components/schemas/Objective"}},"assessment":{"type":"string"},"log":{"type":"array","items":{"$ref":"#/components/schemas/ObjectiveLog"}},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}},"tasks":{"type":"array","items":{"$ref":"#/components/schemas/Task"}},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"sharing":{"$ref":"#/components/schemas/SharingInfo"},"order":{"type":"integer"}},"required":["id","organization","name","active","status","created","sharing","order"]},"StatusInfo":{"type":"object","properties":{"current":{"type":"string"},"changedAt":{"type":"string","format":"date-time"},"changedBy":{"type":"string","format":"uuid"}},"required":["current"]},"CreationInfo":{"type":"object","properties":{"createdAt":{"type":"string","format":"date-time"},"createdBy":{"type":"string","format":"uuid"}},"required":["createdAt"]},"ObjectiveMetric":{"type":"object","properties":{"startingValue":{"type":"number"},"currentValue":{"type":"number"},"targetValue":{"type":"number"},"metricType":{"type":"string"},"metricUnit":{"type":"string"},"logs":{"type":"array","items":{"$ref":"#/components/schemas/MetricLog"}}},"required":["startingValue","currentValue","targetValue"]},"MetricLog":{"type":"object","properties":{"value":{"type":"number"},"loggedAt":{"type":"string","format":"date-time"},"loggedBy":{"type":"string","format":"uuid"}},"required":["value","loggedAt","loggedBy"]},"ObjectiveLog":{"type":"object","properties":{"loggedAt":{"type":"string","format":"date-time"},"loggedBy":{"type":"string","format":"uuid"},"progress":{"type":"number"},"targetValue":{"type":"number"},"assessment":{"type":"string"}}},"EntityAssignee":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"entityType":{"type":"string"}},"required":["entityId","entityType"]},"EntityMapping":{"type":"object","properties":{"app":{"type":"string","format":"uuid"},"namespace":{"type":"string"},"mappedId":{"type":"string"},"reference":{"type":"string"},"mappingData":{"type":"object","additionalProperties":{"type":"string"}},"mappingSecrets":{"type":"object","additionalProperties":{"type":"string"}}},"required":["app","mappedId","mappingData","mappingSecrets"]},"Task":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"assignees":{"type":"array","items":{"$ref":"#/components/schemas/EntityAssignee"}},"organization":{"type":"string","format":"uuid"},"description":{"type":"string"},"dueDate":{"type":"string","format":"date"},"connectedTo":{"$ref":"#/components/schemas/EntityInfo"},"notes":{"type":"array","items":{"$ref":"#/components/schemas/Note"}},"order":{"type":"integer"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}}},"required":["id","name","active","status","created","organization","order"]},"EntityInfo":{"type":"object","properties":{"entityId":{"type":"string","format":"uuid"},"type":{"type":"string"},"organization":{"type":"string","format":"uuid"}},"required":["entityId","type"]},"Note":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"note":{"type":"string"},"author":{"type":"string","format":"uuid"},"createdAt":{"type":"string","format":"date-time"}}},"SharingInfo":{"type":"object","properties":{"visibility":{"type":"string"},"ownerId":{"type":"string","format":"uuid"}}}}},"paths":{"/api/v1/objective/{id}/progress":{"post":{"tags":["OKRs (or Goals)"],"summary":"Log objective progress","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ObjectiveLogRequest"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Objective"}}}},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```

## GET /api/v1/objective-cycle

> List objective cycles

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"OKRs (or Goals)","description":"The OKRs API provides generic functionality for a broad set of Goal types - including OKRs, Rocks or KPIs. For simplicity, these are referenced as OKRs below.  OKRs can be measurable or not and can have any number of children or parents that contribute to its current value.  OKRs can be assigned to both Employees and Groups/Teams and by default are allowed to be assigned an owner and support tasks."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ObjectiveCycle":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"organization":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"description":{"type":"string"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}}},"required":["id","organization","name","active","status","created","startDate","endDate"]},"StatusInfo":{"type":"object","properties":{"current":{"type":"string"},"changedAt":{"type":"string","format":"date-time"},"changedBy":{"type":"string","format":"uuid"}},"required":["current"]},"CreationInfo":{"type":"object","properties":{"createdAt":{"type":"string","format":"date-time"},"createdBy":{"type":"string","format":"uuid"}},"required":["createdAt"]},"EntityMapping":{"type":"object","properties":{"app":{"type":"string","format":"uuid"},"namespace":{"type":"string"},"mappedId":{"type":"string"},"reference":{"type":"string"},"mappingData":{"type":"object","additionalProperties":{"type":"string"}},"mappingSecrets":{"type":"object","additionalProperties":{"type":"string"}}},"required":["app","mappedId","mappingData","mappingSecrets"]}}},"paths":{"/api/v1/objective-cycle":{"get":{"tags":["OKRs (or Goals)"],"summary":"List objective cycles","parameters":[{"name":"status","in":"query","schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ObjectiveCycle"}}}}},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```

## POST /api/v1/objective-cycle

> Create objective cycle

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"OKRs (or Goals)","description":"The OKRs API provides generic functionality for a broad set of Goal types - including OKRs, Rocks or KPIs. For simplicity, these are referenced as OKRs below.  OKRs can be measurable or not and can have any number of children or parents that contribute to its current value.  OKRs can be assigned to both Employees and Groups/Teams and by default are allowed to be assigned an owner and support tasks."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ObjectiveCycleRequest":{"type":"object","properties":{"name":{"type":"string"},"description":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"}},"required":["name","startDate","endDate"]},"ObjectiveCycle":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"organization":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"description":{"type":"string"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}}},"required":["id","organization","name","active","status","created","startDate","endDate"]},"StatusInfo":{"type":"object","properties":{"current":{"type":"string"},"changedAt":{"type":"string","format":"date-time"},"changedBy":{"type":"string","format":"uuid"}},"required":["current"]},"CreationInfo":{"type":"object","properties":{"createdAt":{"type":"string","format":"date-time"},"createdBy":{"type":"string","format":"uuid"}},"required":["createdAt"]},"EntityMapping":{"type":"object","properties":{"app":{"type":"string","format":"uuid"},"namespace":{"type":"string"},"mappedId":{"type":"string"},"reference":{"type":"string"},"mappingData":{"type":"object","additionalProperties":{"type":"string"}},"mappingSecrets":{"type":"object","additionalProperties":{"type":"string"}}},"required":["app","mappedId","mappingData","mappingSecrets"]}}},"paths":{"/api/v1/objective-cycle":{"post":{"tags":["OKRs (or Goals)"],"summary":"Create objective cycle","requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ObjectiveCycleRequest"}}}},"responses":{"201":{"description":"Created","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ObjectiveCycle"}}}},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```

## GET /api/v1/objective-cycle/{id}

> Get objective cycle

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"OKRs (or Goals)","description":"The OKRs API provides generic functionality for a broad set of Goal types - including OKRs, Rocks or KPIs. For simplicity, these are referenced as OKRs below.  OKRs can be measurable or not and can have any number of children or parents that contribute to its current value.  OKRs can be assigned to both Employees and Groups/Teams and by default are allowed to be assigned an owner and support tasks."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ObjectiveCycle":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"organization":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"description":{"type":"string"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}}},"required":["id","organization","name","active","status","created","startDate","endDate"]},"StatusInfo":{"type":"object","properties":{"current":{"type":"string"},"changedAt":{"type":"string","format":"date-time"},"changedBy":{"type":"string","format":"uuid"}},"required":["current"]},"CreationInfo":{"type":"object","properties":{"createdAt":{"type":"string","format":"date-time"},"createdBy":{"type":"string","format":"uuid"}},"required":["createdAt"]},"EntityMapping":{"type":"object","properties":{"app":{"type":"string","format":"uuid"},"namespace":{"type":"string"},"mappedId":{"type":"string"},"reference":{"type":"string"},"mappingData":{"type":"object","additionalProperties":{"type":"string"}},"mappingSecrets":{"type":"object","additionalProperties":{"type":"string"}}},"required":["app","mappedId","mappingData","mappingSecrets"]}}},"paths":{"/api/v1/objective-cycle/{id}":{"get":{"tags":["OKRs (or Goals)"],"summary":"Get objective cycle","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ObjectiveCycle"}}}},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```

## PATCH /api/v1/objective-cycle/{id}

> Update objective cycle

```json
{"openapi":"3.1.0","info":{"title":"Peoplelogic API","version":"1.0.0"},"tags":[{"name":"OKRs (or Goals)","description":"The OKRs API provides generic functionality for a broad set of Goal types - including OKRs, Rocks or KPIs. For simplicity, these are referenced as OKRs below.  OKRs can be measurable or not and can have any number of children or parents that contribute to its current value.  OKRs can be assigned to both Employees and Groups/Teams and by default are allowed to be assigned an owner and support tasks."}],"servers":[{"url":"https://api.peoplelogic.dev"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ObjectiveCycleRequest":{"type":"object","properties":{"name":{"type":"string"},"description":{"type":"string"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"}},"required":["name","startDate","endDate"]},"ObjectiveCycle":{"type":"object","properties":{"id":{"type":"string","format":"uuid"},"organization":{"type":"string","format":"uuid"},"name":{"type":"string"},"active":{"type":"boolean"},"status":{"$ref":"#/components/schemas/StatusInfo"},"created":{"$ref":"#/components/schemas/CreationInfo"},"startDate":{"type":"string","format":"date"},"endDate":{"type":"string","format":"date"},"description":{"type":"string"},"mappings":{"type":"array","items":{"$ref":"#/components/schemas/EntityMapping"}}},"required":["id","organization","name","active","status","created","startDate","endDate"]},"StatusInfo":{"type":"object","properties":{"current":{"type":"string"},"changedAt":{"type":"string","format":"date-time"},"changedBy":{"type":"string","format":"uuid"}},"required":["current"]},"CreationInfo":{"type":"object","properties":{"createdAt":{"type":"string","format":"date-time"},"createdBy":{"type":"string","format":"uuid"}},"required":["createdAt"]},"EntityMapping":{"type":"object","properties":{"app":{"type":"string","format":"uuid"},"namespace":{"type":"string"},"mappedId":{"type":"string"},"reference":{"type":"string"},"mappingData":{"type":"object","additionalProperties":{"type":"string"}},"mappingSecrets":{"type":"object","additionalProperties":{"type":"string"}}},"required":["app","mappedId","mappingData","mappingSecrets"]}}},"paths":{"/api/v1/objective-cycle/{id}":{"patch":{"tags":["OKRs (or Goals)"],"summary":"Update objective cycle","parameters":[{"name":"id","in":"path","required":true,"schema":{"type":"string"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ObjectiveCycleRequest"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ObjectiveCycle"}}}},"400":{"description":"Bad Request – invalid request payload."},"401":{"description":"Unauthorized – missing or invalid JWT."},"403":{"description":"Forbidden – insufficient permissions."},"404":{"description":"Not Found – no Entity with that ID."}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.peoplelogic.dev/api/universal-talent-api/okrs-or-goals.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
